theory Labels
imports Aexp Bexp
begin

datatype 'a label = 
    Skip 
  | Break
  | Assume "'a bexp"
  | Assign 'a "'a aexp"

locale label =
  fixes l :: "'a label" (structure)

locale finite_label = label +
  assumes finite_vars : 
    "case l of 
       Assume e   \<Rightarrow> finite (Bexp.vars e) 
     | Assign _ e \<Rightarrow> finite (Aexp.vars e) 
     | _ \<Rightarrow> True"
begin
  lemmas finite_label = finite_vars
end

definition finite_labels :: 
  "'a label list \<Rightarrow> bool" 
where
  "finite_labels ls = (\<forall> l \<in> set ls. finite_label l)"

lemma finite_labels_Cons :
  "finite_labels (l#ls) \<longleftrightarrow> finite_label l \<and> finite_labels ls"
by (auto simp add : finite_labels_def)

lemma "finite_label Skip" unfolding finite_label_def by simp

find_unused_assms

end
